//+------------------------------------------------------------------+
//|												 Copyright  2010, JACreative |
//|																 KGForexWorld.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, KGForexWorld.com"
#property link      "http://www.kgforexworld.com"

#property indicator_separate_window
#property indicator_buffers 8

#property indicator_level1 0
#property indicator_levelcolor DarkSlateGray

extern	string	Readme1	= "#--- Periode Input",
						Readme2	= "1D 1W 1MH",
						Periode	= "1D",
						Readme3	= "#-- 0=Above, 1=Under";
extern	int		Posisi	= 0;


double	Buffer_Up[],Buffer_Down[],
			RANGE[],
			SD_HI_01[],SD_HI_02[],SD_HI_03[],
			SD_LOW_01[],SD_LOW_02[],SD_LOW_03[],
			TMP_COUNT[20],Hasil;

int 		CBar,PUse,Count,HARI,SAVE_BAR;

color		Warna;

bool		SYDNEY_OPEN	= true;


int init(){

	

	if(GlobalVariableCheck("CBar"))
		CBar = GlobalVariableGet("CBar");
	else	
		GlobalVariableSet("CBar",0);
	
	if(Periode=="1D"){PUse=PERIOD_D1;				Warna=Lime;		Count=20;}
	else if(Periode == "1W"){PUse=PERIOD_W1;		Warna=Magenta;	Count=16;}
	else if(Periode == "1MH"){PUse=PERIOD_MN1;	Warna=Aqua;		Count=12;}	

	SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2,Blue);
	SetIndexBuffer(0,Buffer_Up);
	SetIndexLabel(0,"Buffer Up");

	SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2,Red);
	SetIndexBuffer(1,Buffer_Down);
	SetIndexLabel(1,"Buffer Down");
	
	SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1,Warna);
	SetIndexBuffer(2,RANGE);
	SetIndexLabel(2,"Range");

	SetIndexStyle(3,DRAW_LINE,STYLE_DOT,1,DarkSlateGray);
	SetIndexBuffer(3,SD_HI_01);
	SetIndexLabel(3,"Range SD +1");
	
	SetIndexStyle(4,DRAW_LINE,STYLE_DOT,1,DarkSlateGray);
	SetIndexBuffer(4,SD_HI_02);
	SetIndexLabel(4,"Range SD +2");

	SetIndexStyle(5,DRAW_LINE,STYLE_DOT,1,DarkSlateGray);
	SetIndexBuffer(5,SD_HI_03);
	SetIndexLabel(5,"Range SD +3");


	SetIndexStyle(6,DRAW_LINE,STYLE_DOT,1,DarkSlateGray);
	SetIndexBuffer(6,SD_LOW_01);
	SetIndexLabel(6,"Range SD -1");

	SetIndexStyle(7,DRAW_LINE,STYLE_DOT,1,DarkSlateGray);
	SetIndexBuffer(7,SD_LOW_02);
	SetIndexLabel(7,"Range SD -2");	

	IndicatorShortName("TPoint Average [Periode=" + Periode + "]");
	
	Check_SYDNEY_OPEN();
}

int start(){ 
   int      counted_bars=IndicatorCounted(),
   			i,j,limit,CNT,CALC_BAR;
   
	double	TMP,TMP2,Tampung,
				TMP_TIME=0,RataRata,TMPSTDDEV,AVERAGE;

	datetime TimeArray[];

   if(counted_bars < 0)	return(-1);
   if(counted_bars > 0)	counted_bars--;

	limit	= Bars-counted_bars;
	if((CBar!=0) && (limit>=CBar))
		limit=CBar;
		
   for(i=0; i< limit; i++){

   	// !SYDNEY OPEN
		if((Periode == "1D") && !SYDNEY_OPEN){
			if((SAVE_BAR != iBarShift(NULL,PUse,Time[i])) || !SAVE_BAR){
				SAVE_BAR = iBarShift(NULL,PUse,Time[i]);
				CALC_BAR = SAVE_BAR;
				CNT	= 0;
				RataRata	= 0;
				while(CNT<Count){
					HARI = TimeDayOfWeek(iTime(NULL, PUse, CALC_BAR+1));
					if(HARI != 0){
						TMP_COUNT[CNT]	= (iHigh(NULL, PUse, CALC_BAR+1) - iLow(NULL, PUse, CALC_BAR+1))/Point;
						RataRata += (iHigh(NULL, PUse, CALC_BAR+1) - iLow(NULL, PUse, CALC_BAR+1))/Point;
						CNT++;
					}
					CALC_BAR++;
				}// END WHILE
				RataRata = RataRata/Count;

			}// END IF
		}
		// SYDNEY OPEN
		else{
			if((SAVE_BAR != iBarShift(NULL,PUse,Time[i])) || !SAVE_BAR){
				SAVE_BAR = iBarShift(NULL,PUse,Time[i]);
				CALC_BAR = SAVE_BAR;
				CNT	= 0;
				RataRata	= 0;
				for(j=SAVE_BAR;j<SAVE_BAR+Count;j++){
					TMP_COUNT[CNT]	= (iHigh(NULL, PUse, j+1) - iLow(NULL, PUse, j+1))/Point;
					RataRata += (iHigh(NULL, PUse, j+1) - iLow(NULL, PUse, j+1))/Point;
					CNT++;
				}// END WHILE
				RataRata = RataRata/Count;

			}// END IF
		}	
		TMPSTDDEV			= iStdDevOnArray(TMP_COUNT,Count,Count,0,MODE_SMA,0);
		
		if(Periode=="1D")
   		AVERAGE		= iCustom(NULL, 0, "_KG_AVERAGE","","","HL",false,false,true,false,false,false,false,false,false,false,2,i);
		else if(Periode == "1W")
			AVERAGE		= iCustom(NULL, 0, "_KG_AVERAGE","","","HL",false,false,false,true,false,false,false,false,false,false,3,i);
		else if(Periode == "1MH")
			AVERAGE		= iCustom(NULL, 0, "_KG_AVERAGE","","","HL",false,false,false,false,true,false,false,false,false,false,4,i);

		if(Close[i] > AVERAGE){
			Buffer_Up[i]	= (High[i] - AVERAGE)/Point;
			Buffer_Down[i]	= 0;
		}
		else if(Close[i] < AVERAGE){
			Buffer_Up[i]	= 0;
			Buffer_Down[i]	= (Low[i] - AVERAGE)/Point;
		}
		else{
			Buffer_Up[i]	= 0;
			Buffer_Down[i]	= 0;
		}
		
		if(!Posisi){
			RANGE[i]		= RataRata;
			SD_HI_01[i]	= RataRata + (TMPSTDDEV*1);
			SD_HI_02[i]	= RataRata + (TMPSTDDEV*2);
			SD_HI_03[i]	= RataRata + (TMPSTDDEV*3);
			SD_LOW_01[i]= RataRata - (TMPSTDDEV*1);
			SD_LOW_02[i]= RataRata - (TMPSTDDEV*2);

		}
		else{
			RANGE[i]		= -RataRata;
			SD_HI_01[i]	= -(RataRata + (TMPSTDDEV*1));
			SD_HI_02[i]	= -(RataRata + (TMPSTDDEV*2));
			SD_HI_03[i]	= -(RataRata + (TMPSTDDEV*3));
			SD_LOW_01[i]= -(RataRata - (TMPSTDDEV*1));
			SD_LOW_02[i]= -(RataRata - (TMPSTDDEV*2));

		}
			
	}


}

void Check_SYDNEY_OPEN (){
	int i;

	for(i=0; i<=10; i++){
		if((TimeDayOfWeek(iTime(NULL, PERIOD_D1, i)) == 6) || (TimeDayOfWeek(iTime(NULL, PERIOD_D1, i)) == 0)){
			SYDNEY_OPEN = false;
			return(0);
		}
	}
}
